#!/usr/bin/perl -w
###############################################################################
# GT-Chat (http://www.gt-chat.de)                                             #
# GT-Chat 0.95 Copyright (c) 2006-2008 by Sascha Heldt                        #
###############################################################################
use strict;

my ($file,$fromdir,$todir) = @ARGV;

die "Usage: $0 <description-file> <from-dir> <to-dir>" unless defined($todir);

my $description = do($file);
die "Error occured when loading $file: $@" if ($@);
die "$file did not return a true value" unless $description;
die "The return value of $file is not a hash reference" unless UNIVERSAL::isa($description,'HASH');

foreach my $template (keys %$description)
{
	my $texts = $description->{$template};

	print "Building template $template...\n";

	my $ext = 'html';
	$ext = 'mail' if -e "$fromdir/$template.mail";

	if (-e "$todir/$template.$ext")
	{
#        print "$todir/$template.$ext already exists, renaming to $todir/$template.$ext.bak\n";
		rename("$todir/$template.$ext","$todir/$template.$ext.bak");
	}

	open(local* IN,"$fromdir/$template.$ext") || ((print STDERR "Could not open file $fromdir/$template.$ext\n") && next);
	open(local* OUT,">$todir/$template.$ext") || ((print STDERR "Could not create file $todir/$template.$ext\n") && next);

	my $first = 1;
	foreach (<IN>)
	{
		unless ($first && /LanguageIndependentTemplateEngine\.pm/)
		{
			s/\r//g;
			s/\{TEXT\|(\w+)\}/$texts->{$1}/g;
			print OUT $_;
		}
		$first = 0;
	}

	close(IN);
	close(OUT);

	print "Building template $template complete\n";
}
